import React from 'react';
import { DetailedVersion, VersionDropdown } from '@teambit/component.ui.version-dropdown';
import { useUpdatedUrlFromQuery } from '@teambit/component.ui.component-compare.hooks.use-component-compare-url';
import { useComponentCompare } from '@teambit/component.ui.component-compare.context';
import { useComponent } from '@teambit/component';
import classNames from 'classnames';
import * as semver from 'semver';
import styles from './component-compare-version-picker.module.scss';
export function ComponentCompareVersionPicker({ className, host, customUseComponent, }) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    const componentCompare = useComponentCompare();
    const compare = (_a = componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.compare) === null || _a === void 0 ? void 0 : _a.model;
    const componentId = compare === null || compare === void 0 ? void 0 : compare.id.toString();
    const componentWithLogsOptions = {
        customUseComponent,
    };
    const useVersions = (props) => {
        const { skip } = props || {};
        const { componentLogs = {}, loading: loadingLogs } = useComponent(host, componentId, Object.assign(Object.assign({}, componentWithLogsOptions), { skip }));
        return Object.assign(Object.assign({ loading: loadingLogs }, componentLogs), { snaps: (componentLogs.logs || [])
                .map((snap) => (Object.assign(Object.assign({}, snap), { version: snap.hash })))
                .filter((log) => {
                var _a;
                if (log.tag)
                    return false;
                const version = log.hash;
                return ((_a = componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.compare) === null || _a === void 0 ? void 0 : _a.hasLocalChanges) || version !== (compare === null || compare === void 0 ? void 0 : compare.id.version);
            }), tags: (componentLogs.logs || [])
                .map((tag) => (Object.assign(Object.assign({}, tag), { version: tag.tag })))
                .filter((log) => {
                var _a;
                if (!log.tag)
                    return false;
                const version = log.tag;
                return ((_a = componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.compare) === null || _a === void 0 ? void 0 : _a.hasLocalChanges) || version !== (compare === null || compare === void 0 ? void 0 : compare.id.version);
            }) });
    };
    const useVersion = (props) => {
        const { version, skip } = props || {};
        const { tags, snaps, loading } = useVersions({ skip });
        const isTag = React.useMemo(() => semver.valid(version), [loading, version]);
        if (isTag) {
            return React.useMemo(() => tags === null || tags === void 0 ? void 0 : tags.find((tag) => tag.tag === version), [loading, tags === null || tags === void 0 ? void 0 : tags.length, version]);
        }
        return React.useMemo(() => snaps === null || snaps === void 0 ? void 0 : snaps.find((snap) => snap.version === version), [loading, snaps === null || snaps === void 0 ? void 0 : snaps.length, version]);
    };
    const compareVersion = ((_b = componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.compare) === null || _b === void 0 ? void 0 : _b.hasLocalChanges) ? 'workspace' : compare === null || compare === void 0 ? void 0 : compare.version;
    const baseVersion = (_c = componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.base) === null || _c === void 0 ? void 0 : _c.model.version;
    const key = `base-compare-version-dropdown-${(_d = componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.compare) === null || _d === void 0 ? void 0 : _d.model.id.toString()}`;
    return (React.createElement("div", { className: styles.componentCompareVersionPicker },
        React.createElement("div", { className: classNames(styles.titleText, styles.rightPad) }, "Comparing"),
        React.createElement(VersionDropdown, { key: key, className: classNames(styles.componentCompareVersionContainer, styles.left, className), dropdownClassName: styles.componentCompareDropdown, placeholderClassName: styles.componentCompareVersionPlaceholder, menuClassName: classNames(styles.componentCompareVersionMenu, styles.showMenuOverNav), currentVersion: baseVersion, loading: componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.loading, overrideVersionHref: (_baseVersion) => {
                return useUpdatedUrlFromQuery({ baseVersion: _baseVersion });
            }, disabled: ((_f = (_e = compare === null || compare === void 0 ? void 0 : compare.logs) === null || _e === void 0 ? void 0 : _e.length) !== null && _f !== void 0 ? _f : 0) < 2, hasMoreVersions: ((_h = (_g = compare === null || compare === void 0 ? void 0 : compare.logs) === null || _g === void 0 ? void 0 : _g.length) !== null && _h !== void 0 ? _h : 0) > 1, showVersionDetails: true, useComponentVersions: useVersions, useCurrentVersionLog: useVersion, PlaceholderComponent: DetailedVersion }),
        React.createElement("div", { className: styles.titleText }, "with"),
        React.createElement(VersionDropdown, { className: classNames(styles.componentCompareVersionContainer, styles.right), dropdownClassName: styles.componentCompareDropdown, placeholderClassName: styles.componentCompareVersionPlaceholder, menuClassName: styles.componentCompareVersionMenu, disabled: true, loading: componentCompare === null || componentCompare === void 0 ? void 0 : componentCompare.loading, currentVersion: compareVersion, PlaceholderComponent: DetailedVersion, useCurrentVersionLog: useVersion, showVersionDetails: true })));
}
//# sourceMappingURL=component-compare-version-picker.js.map